---
title: Set watch expressions
slug: Tools/Debugger/How_to/Set_Watch_Expressions
tags:
  - Firefox
  - Tools
  - watch expressions
---
<div>{{ToolsSidebar}}</div>

<p>The Debugger <em>Watch expressions</em> pane allows you to specify JavaScript expressions that will be reevaluated and displayed every time the debugger pauses. As you step through code, the debugger will watch the expression and return any results. Watches are most commonly used to group individual <em>variables</em> of interest for easier observation. Watching more complicated expressions can sometimes also be useful: for example, to check that variables are within certain limits or values.</p>

<p>The screenshot below shows the <em>Watch expressions</em> panel with a number of expressions already defined. Each line shows the expression and its value at the current step, separated by a colon. Expressions that evaluate to an object can be expanded using the caret symbol to the left.</p>

<p><img alt="Screenshot showing the Watch expressions dialog after the + button has been pressed (for entry of a new watch expression)" src="https://mdn.mozillademos.org/files/17448/ff_watch_expressions_add.png" style="border-style: solid; border-width: 1px; display: block; height: 391px; margin: 0 auto; width: 484px;"></p>

<p>To add a watch expression click the <strong>+</strong> button in the top right corner of the panel. Then type the expression into the text entry field that appears at the bottom of the panel, and press <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: #eeeeee; font-size: 13.6px; white-space: nowrap;"><strong>Enter</strong></span></font> to save it. The expression will be evaluated when you save, when you step through the code, or when you select the <em>Refresh</em> icon (next to <strong>+</strong>).</p>

<p>You can enter any valid expression into the watch, and even declare new "watch" variables and re-use them. For example, <code>mywatchvar1 = 3</code> and <code>mywatchvar2 = mywatchvar1 + 2</code> will evaluate <code>mywatchvar2</code> as 5. You can also declare an expression that modifies a variable value in the code, and this will be re-evaluated whenever you step through the code or refresh the watch expression.</p>

<div class="notecard warning">
<p><strong>Important</strong>: Changing values in the code using a watch expression may affect normal code execution.</p>
</div>

<p>To remove a watch expression, select the <strong>X</strong> button that appears when you hover over a line.</p>

<p><img alt="Hover over watch expression to get X that can be clicked to remove an expression." src="https://mdn.mozillademos.org/files/17449/ff_watch_expressions_remove.png" style="border-style: solid; border-width: 1px; display: block; height: 131px; margin: 0 auto; width: 478px;"></p>
